VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmBlockNummeriert 
   Caption         =   "Blcke nummerieren"
   ClientHeight    =   4080
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9315
   OleObjectBlob   =   "frmBlockNummeriert.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "frmBlockNummeriert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim blkColl As AcadBlocks
Dim WinkelLIOld As Integer
Dim BName As String
Dim objBlock As AcadBlock
Dim Elem As AcadEntity
Dim AttribJaNein As Boolean
Dim IndexAttrib As Integer

Private Sub lblFeletic_Click()

End Sub

Private Sub UserForm_Initialize()
    Dim index As Integer
    Dim BAtts As Variant
    Dim fldBlockCount As Double
    Dim BNameVergleich As String
    Dim IndexBlock As Integer
    Dim BCompare As Integer
    
    Dim aceBlock As AcadBlock
    Dim aceEntity As AcadEntity
    
    Dim Winkeleinheit As Double
    Dim LIndex As Double
    
    changeStatus = False
    
    fldWert.value = 1
    fldZaehler.value = 1
    fldVorkomma.value = 3
    fldNachkomma.value = 0
    
    ' Suchen nach Blcken mit Attributen
    Set blkColl = ThisDrawing.Blocks
    
    For Each objBlock In blkColl
        
        AttribJaNein = False
        
        On Error GoTo Err_Control
        For Each Elem In objBlock
            Select Case Elem.EntityType
                Case acAttribute
                    AttribJaNein = True
                    Exit For
                Case Else
            End Select
        Next Elem
                
        If AttribJaNein = True Then
            BName = objBlock.Name
                    
            If Left$(BName, 1) <> "*" Then
            
                fldBlockCount = fldBlock.ListCount
                
                If fldBlockCount = 0 Then
                    fldBlock.AddItem BName           'ListIndex = 0
                Else
                
                    For IndexBlock = 0 To fldBlockCount - 1 Step 1
                    
                        BNameVergleich = fldBlock.list(IndexBlock)
                        BCompare = StrComp(BName, BNameVergleich, 1)
                        
                        Select Case BCompare
                            Case 1
                                If IndexBlock = fldBlockCount - 1 Then fldBlock.AddItem BName
                            Case -1
                                fldBlock.AddItem BName, IndexBlock
                                IndexBlock = fldBlockCount - 1
                        End Select
    
                    Next
                    
                End If
                    
                
            End If
        
        End If
NO_ACADELEM:
    
    Next
    
    On Error Resume Next
    fldBlock.ListIndex = 0         'Set combo box to entry
        If Err Then
            MultiPage.Pages("mpgBlock").Enabled = False
        End If
    
    fldBlock.BoundColumn = 0            'Combo box values are ListIndex values
    BName = fldBlock.text
    
    fldAttrib.Clear
    
    Set aceBlock = ThisDrawing.Blocks(BName)
    
    IndexAttrib = 0
    
    For Each aceEntity In aceBlock
        Select Case aceEntity.EntityType
            Case acAttribute
                
                Dim aceAttDef As AcadAttribute
                Set aceAttDef = aceEntity
                
                fldAttrib.AddItem aceAttDef.TagString, IndexAttrib
                IndexAttrib = IndexAttrib + 1
        End Select
    
    Next aceEntity
    
    
    If fldAttrib.ListCount = 0 Then
    Else
        fldAttrib.ListIndex = 0         'Set combo box to entry
        fldAttrib.BoundColumn = 0            'Combo box values are ListIndex values
    End If
    
    Winkeleinheit = ThisDrawing.GetVariable("AUNITS")
    Select Case Winkeleinheit
        Case Is = 0
            LIndex = 0
        Case Is = 2
            LIndex = 1
        Case Is = 3
            LIndex = 2
        Case Else
            LIndex = 0
    End Select
    
    ' Winkeleinheiten in Feld eintragen
    fldWinkelBez.AddItem " Grad"           'ListIndex = 0
    fldWinkelBez.AddItem "g Gon"            'ListIndex = 1
    fldWinkelBez.AddItem "rad Radian"       'ListIndex = 2
    fldWinkelBez.BoundColumn = 0            'Combo box values are ListIndex values
    fldWinkelBez.ListIndex = LIndex         'Set combo box to entry
    WinkelLIOld = LIndex                    'Setz alten ListIndex auf Zeichnungseinheit

    ' Textgren in Feld eintragen
    fldTextHeight.AddItem "1,3 mm"              'ListIndex = 0
    fldTextHeight.AddItem "1,8 mm"              'ListIndex = 1
    fldTextHeight.AddItem "2,0 mm"              'ListIndex = 2
    fldTextHeight.AddItem "2,5 mm"              'ListIndex = 3
    fldTextHeight.AddItem "3,0 mm"              'ListIndex = 4
    fldTextHeight.AddItem "3,5 mm"              'ListIndex = 5
    fldTextHeight.ListIndex = 3                 'Setzt ListIndex (Anzeige) auf "2,5 mm"
    
    MultiPage.value = 0
    
    Call fldWert_AfterUpdate
    
    Exit Sub

Err_Control:
    Resume NO_ACADELEM
End Sub

Private Sub fldBlock_Change()
    
    Dim BAtts As Variant
    
    fldAttrib.Clear
    
    BName = fldBlock.text
    
    Dim aceBlock As AcadBlock
    On Error Resume Next
    Set aceBlock = ThisDrawing.Blocks(BName)
    If Err Then Exit Sub
    
    Dim aceEntity As AcadEntity
    
    IndexAttrib = 0
    
    For Each aceEntity In aceBlock
    
        Select Case aceEntity.EntityType
            Case acAttribute
                
                Dim aceAttDef As AcadAttribute
                Set aceAttDef = aceEntity
                
                fldAttrib.AddItem aceAttDef.TagString, IndexAttrib
                IndexAttrib = IndexAttrib + 1
                
        End Select
      
    
    Next aceEntity
    
    If fldAttrib.ListCount = 0 Then
    Else
        fldAttrib.ListIndex = 0         'Set combo box to entry
        fldAttrib.BoundColumn = 0            'Combo box values are ListIndex values
    End If
End Sub

Private Sub fldPrefix_AfterUpdate()
    Call fldWert_AfterUpdate
End Sub

Private Sub fldSuffix_AfterUpdate()
    Call fldWert_AfterUpdate
End Sub

Private Sub fldWert_AfterUpdate()
    
    Dim WertChk As Double
    
    If funStringIsKommazahl(fldWert.text) = True Then fldWert.text = funKomma(fldWert.text)
    
    On Error Resume Next
    WertChk = fldWert.text
    If Err Then
        lblKomma.Enabled = False: fldVorkomma.Enabled = False: fldNachkomma.Enabled = False
        lblVKomma.Enabled = False: lblNKomma.Enabled = False: lblKommaZ.Enabled = False
        
        fldZaehler.text = Format(Abs(fldZaehler.text), "0")
        
        fldPreview.text = fldPrefix.text & fldWert.text & fldSuffix.text
    Else
        fldWert.text = funKomma(fldWert.text)
        lblKomma.Enabled = True: fldVorkomma.Enabled = True: fldNachkomma.Enabled = True
        lblVKomma.Enabled = True: lblNKomma.Enabled = True: lblKommaZ.Enabled = True
        
        If LTrim(str(funStellenVorKomma(fldWert.text))) > fldVorkomma.value Then fldVorkomma.value = LTrim(str(funStellenVorKomma(fldWert.text)))
        If LTrim(str(funStellenNachKomma(fldWert.text))) > fldNachkomma.value Then fldNachkomma.value = LTrim(str(funStellenNachKomma(fldWert.text)))
        
        fldPreview.text = fldPrefix.text & Format(fldWert.text, _
                          IIf(fldNachkomma.value = 0, String(fldVorkomma.value, "0"), _
                                                      String(fldVorkomma.value, "0") & "." & String(fldNachkomma.value, "0"))) _
                          & fldSuffix.text
    End If
    
End Sub

Private Sub fldWert_Change()
    
    If funStringIsKommazahl(fldWert.text) = True Then fldWert.text = funKomma(fldWert.text)
    
End Sub

Private Sub fldZaehler_AfterUpdate()
    Dim ZaehlerChk As Double
    
'    If funStringIsKommazahl(fldZaehler.Text) = True Then fldZaehler.Text = funKomma(fldZaehler.Text)
    
    On Error Resume Next
    ZaehlerChk = fldZaehler.text
    If Err Then
        MsgBox "Falsche Eingabe!" & Chr(10) & Chr(10) & _
               "Nur Zahlen mglich." & Chr(10) & Chr(10) & _
               "Wert wird auf ""1"" gesetzt."
        fldZaehler.value = 1
'        SendKeys "+{TAB}"
    Else
        
        If LTrim(str(funStellenVorKomma(fldZaehler.text))) > fldVorkomma.value Then fldVorkomma.value = LTrim(str(funStellenVorKomma(fldZaehler.text)))
        If LTrim(str(funStellenNachKomma(fldZaehler.text))) > fldNachkomma.value Then fldNachkomma.value = LTrim(str(funStellenNachKomma(fldZaehler.text)))
        
        fldPreview.text = fldPrefix.text & Format(fldWert.text, _
                          IIf(fldNachkomma.value = 0, String(fldVorkomma.value, "0"), _
                                                      String(fldVorkomma.value, "0") & "." & String(fldNachkomma.value, "0"))) _
                          & fldSuffix.text
    End If
    Call fldWert_AfterUpdate
End Sub

Private Sub fldZaehler_Change()
    
    If funStringIsKommazahl(fldZaehler.text) = True Then fldZaehler.text = funKomma(fldZaehler.text)
    
End Sub

Private Sub fldVorkomma_AfterUpdate()
    Call fldZaehler_AfterUpdate
End Sub

Private Sub fldNachkomma_AfterUpdate()
    Call fldZaehler_AfterUpdate
End Sub

Private Sub optAngleYes_Click()
    btnWinkelPick.Enabled = False: fldWinkel.Enabled = False: fldWinkelBez.Enabled = False
End Sub

Private Sub optAngleNo_Click()
    btnWinkelPick.Enabled = True: fldWinkel.Enabled = True: fldWinkelBez.Enabled = True
End Sub

Private Sub fldWinkel_Change()
    If fldWinkel.text = " " Then fldWinkel.text = "0"
End Sub

Private Sub fldWinkel_AfterUpdate()
    fldWinkel.text = funRechnung(fldWinkel.text)
    
    Dim ObjRotChk As Double
    
    On Error Resume Next
    ObjRotChk = fldWinkel.text
    If Err Then
        MsgBox "Falsche Eingabe!" & Chr(10) & Chr(10) & _
               "Nur Zahlen mit einem Rechenoperator" & Chr(10) & _
               "(+, -, * (oder x), / (oder :) mglich." & Chr(10) & Chr(10) & _
               "Wert wird auf ""0"" gesetzt."
        fldWinkel.text = Abs(ObjRotChk)
        SendKeys "+{TAB}"
    End If
    
End Sub

Private Sub btnWinkelPick_Click()
    Dim Winkel As Double
        
    hide
    On Error Resume Next
        Winkel = ThisDrawing.Utility.GetAngle(, "Winkel")
        If Err Then
        Else
            Select Case fldWinkelBez.ListIndex
                Case Is = 0
                    Winkel = Winkel * 180 / funPI
                Case Is = 1
                    Winkel = Winkel * 200 / funPI
            End Select
            fldWinkel.text = Winkel
        End If
    Show
    
    SendKeys "+{TAB}" & "+{TAB}" & "+{TAB}" & "+{TAB}"

End Sub

Private Sub fldWinkelBez_Change()
    Select Case fldWinkelBez.ListIndex
        Case Is = 0
            Select Case WinkelLIOld
                Case Is = 1
                    fldWinkel.text = fldWinkel.text * (18 / 20)
                Case Is = 2
                    fldWinkel.text = fldWinkel.text * (180 / funPI)
            End Select
        Case Is = 1
            Select Case WinkelLIOld
                Case Is = 0
                    fldWinkel.text = fldWinkel.text * (20 / 18)
                Case Is = 2
                    fldWinkel.text = fldWinkel.text * (200 / funPI)
            End Select
        Case Is = 2
            Select Case WinkelLIOld
                Case Is = 0
                    fldWinkel.text = fldWinkel.text * (funPI / 180)
                Case Is = 1
                    fldWinkel.text = fldWinkel.text * (funPI / 200)
            End Select
    End Select
    WinkelLIOld = fldWinkelBez.ListIndex
End Sub

Private Sub btnOK_Click()
    
    Select Case fldWinkelBez.ListIndex
        Case Is = 0
            fldWinkel.text = fldWinkel.text * (funPI / 180)
        Case Is = 1
            fldWinkel.text = fldWinkel.text * (funPI / 200)
    End Select
        
    changeStatus = True
    hide
    
End Sub

Private Sub btnCancel_Click()
    hide
End Sub



